<template>
    <div class="profile">
        <v-row class="pl-16 pr-16">
            <v-col cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row class="pl-16 pr-16">
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.PAYMENTEDIT') }}
                        </h1>
                        <v-breadcrumbs
                            ><v-breadcrumbs-item
                                class="text-red pointer"
                                @click="goToPage(menus.PAYMENT.id)"
                                >{{
                                    $t('dashboard.menu.PAYMENT')
                                }}</v-breadcrumbs-item
                            ><v-breadcrumbs-divider>/</v-breadcrumbs-divider>
                            <v-breadcrumbs-item disabled>{{
                                $t('dashboard.menu.PAYMENTEDIT')
                            }}</v-breadcrumbs-item></v-breadcrumbs
                        >
                    </v-col>
                </v-row>
                <v-form
                    v-show="pageLoaded"
                    ref="paymentForm"
                    lazy-validation
                    @submit.prevent
                >
                    <v-row class="pl-16 pr-16 pb-16">
                        <v-col>
                            <v-row>
                                <v-col
                                    md="6"
                                    cols="12"
                                    class="form-field font-metropolis-regular"
                                >
                                    <!-- FIRST NAME -->
                                    <v-text-field
                                        ref="firstName"
                                        v-model="form.firstName.value"
                                        :label="$t('form.firstName.text')"
                                        :placeholder="
                                            $t('form.firstName.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field>
                                </v-col>
                                <v-col
                                    md="6"
                                    cols="12"
                                    class="form-field font-metropolis-regular"
                                >
                                    <!-- LAST NAME -->
                                    <v-text-field
                                        ref="lastName"
                                        v-model="form.lastName.value"
                                        :label="$t('form.lastName.text')"
                                        :placeholder="
                                            $t('form.lastName.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field>
                                </v-col>
                                <v-col
                                    cols="12"
                                    class="form-field font-metropolis-regular"
                                >
                                    <!-- CREDIT CARD NUMBER -->
                                    <v-text-field
                                        ref="cc"
                                        v-model="form.cc.value"
                                        v-mask="'#### #### #### ####'"
                                        :rules="[requiredRules]"
                                        name="input-10-2"
                                        :label="$t('form.cc.text')"
                                        :placeholder="$t('form.cc.placeholder')"
                                        class="input-group--focused"
                                        solo
                                        @click:append="showPass = !showPass"
                                        ><template slot="append">
                                            <img
                                                :src="visa"
                                                width="51"
                                                height="17"
                                                class="mr-2"
                                            />
                                            <img
                                                :src="master"
                                                width="35"
                                                height="19"
                                            /> </template
                                    ></v-text-field>
                                </v-col>
                                <v-col
                                    md="6"
                                    cols="12"
                                    class="form-field font-metropolis-regular"
                                >
                                    <!-- EXPIRY DATE -->
                                    <v-text-field
                                        ref="expiryDate"
                                        v-model="form.expiryDate.value"
                                        v-mask="'##/##'"
                                        :label="$t('form.expiryDate.text')"
                                        :placeholder="
                                            $t('form.expiryDate.placeholder')
                                        "
                                        solo
                                        :rules="[requiredRules]"
                                    ></v-text-field>
                                </v-col>
                                <v-col
                                    md="6"
                                    cols="12"
                                    class="form-field font-metropolis-regular"
                                >
                                    <!-- CVV -->
                                    <v-tooltip v-model="showCVV" top>
                                        <template
                                            v-slot:activator="{
                                                on,
                                            }"
                                        >
                                            <v-text-field
                                                ref="cvv"
                                                v-model="form.cvv.value"
                                                v-mask="'###'"
                                                :label="$t('form.cvv.text')"
                                                :placeholder="
                                                    $t('form.cvv.placeholder')
                                                "
                                                solo
                                                :rules="[
                                                    requiredRules,
                                                    requiredCVV,
                                                ]"
                                                append-icon="mdi-information-outline"
                                                @click:append="
                                                    showCVV = !showCVV
                                                "
                                            ></v-text-field>
                                        </template>
                                        <span>{{ $t('form.cvv.hint') }} </span>
                                    </v-tooltip>
                                </v-col>
                            </v-row>
                            <v-row>
                                <v-col>
                                    <v-btn
                                        :loading="loading"
                                        :disabled="loading"
                                        class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                                        color="badge"
                                        @click="validateForm"
                                        >{{ $t('buttons.saveBtn') }}</v-btn
                                    >
                                </v-col>
                            </v-row>
                        </v-col>
                    </v-row>
                </v-form>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import MenuBar from '~/components/dashboard/menuBar.vue'
const { VueMaskDirective } = require('v-mask')

Vue.component('menu-bar', MenuBar)
Vue.directive('mask', VueMaskDirective)

@Component({
    middleware: ['authenticate'],
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
    }),
})
export default class PaymentEdit extends Vue {
    // Data
    $refs!: { paymentForm: HTMLFormElement }
    ref: any = this.$refs
    pageLoaded: boolean = true
    menus!: any
    selectedPage: Number = 5 // payment
    loading: Boolean = false
    selectedPlan: Number = 0 // default plan
    showCVV: Boolean = false
    showPass: Boolean = false
    visa: String = require('~/assets/images/visa.png')
    master: String = require('~/assets/images/mastercard.png')
    isButtonDisabled = false
    formHasErrors: Boolean = false
    form: { [key: string]: any } = {
        firstName: {
            value: '',
            error: null,
            requestKey: 'first_name',
        },
        lastName: {
            value: '',
            error: null,
            requestKey: 'last_name',
        },
        cc: {
            value: '',
            error: null,
            requestKey: 'cc',
        },
        expiryDate: {
            value: '',
            error: null,
            requestKey: 'expiry_date',
        },
        cvv: {
            value: '',
            error: null,
            requestKey: 'cvv',
        },
    }

    plans: any = [
        {
            name: 'Hype2u Basic',
            price: 'RM299/month',
            features: [
                this.$t('home.plan1Feature1'),
                this.$t('home.plan1Feature2'),
                this.$t('home.plan1Feature3'),
                this.$t('home.plan1Feature4'),
                this.$t('home.plan1Feature5'),
                this.$t('home.plan1Feature6'),
            ],
        },
        {
            name: 'Hype2u Unlimited',
            price: 'RM499/month',
            features: [
                this.$t('home.plan2Feature1'),
                this.$t('home.plan2Feature2'),
                this.$t('home.plan2Feature3'),
                this.$t('home.plan2Feature4'),
                this.$t('home.plan2Feature5'),
                this.$t('home.plan2Feature6'),
            ],
        },
    ]

    genderList: any = ['Male', 'Female']
    sizeList: any = ['XS', 'S', 'M', 'L', 'XL', 'XXL']

    // Methods
    goToPage(id: Number) {
        switch (id) {
            case this.menus.PAYMENT.id:
                this.$router.push(this.menus.PAYMENT.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    validateForm() {
        if (typeof this.$refs === 'undefined') {
            return
        }

        setTimeout(() => {
            const valid = this.$refs.paymentForm.validate()

            if (valid) {
                this.submit()
            }
        }, 300)
    }

    submit() {
        alert('save')
    }

    // Rules
    requiredRules(v: string) {
        if (v) {
            return true
        } else {
            return this.$t('form.validation.required')
        }
    }

    requiredEmail(v: string) {
        if (v) {
            if (v.length > 0) {
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                return (
                    pattern.test(v) || this.$t('form.validation.invalidEmail')
                )
            }
        }
        return this.$t('form.validation.required')
    }

    requiredMin(v: string) {
        if (v) {
            if (v.length >= 8) {
                return true
            }
        }
        return this.$t('form.password.min')
    }

    requiredCVV(v: string) {
        if (v) {
            if (v.length === 3) {
                return true
            }
        }
        return this.$t('form.cvv.max')
    }

    mounted() {
        if (typeof this.$refs !== 'undefined') {
            this.ref = this.$refs
            this.pageLoaded = true
        }
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
    }
}
</script>
